package com.Felipe;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseMotionListener;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;
import javax.swing.border.LineBorder;

import com.Felipe.Drawing.GraphPanel;
import com.Felipe.Wave.ActionZvukovyOtisk;
import com.Felipe.Wave.RezOtiskuZvuku;
import com.Felipe.Wave.DetektorVlastnosti;
import com.musicg.wave.Wave;


public class UiAnalyzator extends JFrame {

	//----------------------------------GUI------------------------------------//
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private GraphPanel graphPanel;
	DefaultListModel<RezOtiskuZvuku> model = new DefaultListModel<>();
	private GraphPanel graphPanel_dev;
	private GraphPanel graphPanel_ZCR;
	private GraphPanel graphPanel_frequency;
	private JList<RezOtiskuZvuku> list;
	private final Action action = new SwingAction();
	private JTextField txtVzorkytxt;

	int sx, sGraph;
	boolean isDrag = false;
	
	/**
	 * Bh aplikace.
	 */
	

void Initialize(){
		
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 773, 475);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
		
		JPanel panel_4 = new JPanel();
		contentPane.add(panel_4);
		panel_4.setLayout(new BoxLayout(panel_4, BoxLayout.X_AXIS));
		
		JPanel panel_left = new JPanel();
		panel_4.add(panel_left);
		panel_left.setLayout(new BoxLayout(panel_left, BoxLayout.Y_AXIS));
		
		JPanel panel_2 = new JPanel();
		panel_left.add(panel_2);
		panel_2.setLayout(new BoxLayout(panel_2, BoxLayout.Y_AXIS));
		
		JLabel lblIntensityGraph = new JLabel("Intenzita");
		panel_2.add(lblIntensityGraph);
		
		graphPanel = new GraphPanel();
		
		
		panel_2.add(graphPanel);
		
		JPanel panel_3 = new JPanel();
		panel_left.add(panel_3);
		panel_3.setLayout(new BoxLayout(panel_3, BoxLayout.Y_AXIS));
		
		JLabel lblStandardDeviationGraph = new JLabel("Smrodatn odchylka");
		panel_3.add(lblStandardDeviationGraph);
		
		graphPanel_dev = new GraphPanel();
		panel_3.add(graphPanel_dev);
		
		JPanel panel_mid = new JPanel();
		panel_4.add(panel_mid);
		panel_mid.setLayout(new BoxLayout(panel_mid, BoxLayout.Y_AXIS));
		
		JPanel panel_1 = new JPanel();
		panel_mid.add(panel_1);
		panel_1.setLayout(new BoxLayout(panel_1, BoxLayout.Y_AXIS));
		
		JLabel lblGraph = new JLabel("Poet prchod nulou");
		panel_1.add(lblGraph);
		
		graphPanel_ZCR = new GraphPanel();
		panel_1.add(graphPanel_ZCR);
		
		JPanel panel_5 = new JPanel();
		panel_mid.add(panel_5);
		panel_5.setLayout(new BoxLayout(panel_5, BoxLayout.Y_AXIS));
		
		JLabel lblFrequencyGraph = new JLabel("Frekvence");
		panel_5.add(lblFrequencyGraph);
		
		graphPanel_frequency = new GraphPanel();
		panel_5.add(graphPanel_frequency);
		
		JPanel panel_6 = new JPanel();
		panel_4.add(panel_6);
		panel_6.setLayout(new BoxLayout(panel_6, BoxLayout.Y_AXIS));
		
		JPanel panel_7 = new JPanel();
		panel_6.add(panel_7);
		panel_7.setLayout(new BoxLayout(panel_7, BoxLayout.Y_AXIS));
		
		JLabel lblSamples = new JLabel("Oznaen Vzorky");
		panel_7.add(lblSamples);
		lblSamples.setHorizontalAlignment(SwingConstants.CENTER);
		
		JScrollPane scrollPane = new JScrollPane();
		panel_7.add(scrollPane);
		
		list = new JList<RezOtiskuZvuku>();
		list.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(arg0.getClickCount()==2){
					RezOtiskuZvuku slice = (RezOtiskuZvuku) ((JList<?>)arg0.getComponent()).getSelectedValue();
					if(slice!=null){
					String name= JOptionPane.showInputDialog("Pejmenovat");
					slice.jmenoRezu = name;
					}


				}
			}
		});
		list.setModel(model);
		scrollPane.setViewportView(list);
		
		JPopupMenu popupMenu = new JPopupMenu();
		addPopup(list, popupMenu);
		
		JMenuItem mntmDelete = new JMenuItem("Smazat");
		mntmDelete.setAction(action);
		popupMenu.add(mntmDelete);
		
		JPanel panel = new JPanel();
		contentPane.add(panel);
		
		final JButton btnRecord = new JButton("Nahraj");
		btnRecord.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnRecord.getText().equals("Nahraj")){
					btnRecord.setText("Stop");
					StartRecording();
				}
				else{
					btnRecord.setText("Nahraj");
					StopRecording();
				}
			}
		});
		panel.add(btnRecord);
		
		btnPlay = new JButton("Pehraj");
		btnPlay.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent paramMouseEvent) {
				if(btnPlay.getText().equals("Pehraj"))
				{
					btnPlay.setText("Stop");
					startPlayback();
					
				}
				else{
					btnPlay.setText("Pehraj");
					stopPlayback();
					
				}
			}
		});
		panel.add(btnPlay);
		
		JPanel panel_9 = new JPanel();
		panel_9.setBorder(new LineBorder(new Color(0, 0, 0)));
		panel.add(panel_9);
		
		txtVzorkytxt = new JTextField();
		txtVzorkytxt.setText("vzorky.txt");
		panel_9.add(txtVzorkytxt);
		txtVzorkytxt.setColumns(10);
		
		JButton btnExportSamples = new JButton("Export Vzorku");
		panel_9.add(btnExportSamples);
		btnExportSamples.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				exportSamples();
			}
		});
		
		JPanel panel_8 = new JPanel();
		panel_8.setBorder(new LineBorder(new Color(0, 0, 0)));
		panel.add(panel_8);
		
		JButton btnClearGraphs = new JButton("Vyisti Grafy");
		panel_8.add(btnClearGraphs);
		btnClearGraphs.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				getGraphPanel().clearGraphs();
				getGraphPanel_dev().clearGraphs();
				getGraphPanel_frequency().clearGraphs();
				getGraphPanel_ZCR().clearGraphs();
			}
		});
		
		
		
		MouseAdapter ma =  new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				GraphPanel gp = ((GraphPanel)arg0.getComponent());
				int  i  = gp.getSelectedX();
				
				if(i!=-1){
					RezOtiskuZvuku slice = new RezOtiskuZvuku();
					slice.intenzita = getGraphPanel().getSelectedValue();
					slice.frekvence = getGraphPanel_frequency().getSelectedValue();
					slice.smerOdchylka = getGraphPanel_dev().getSelectedValue();
					slice.ZeroCrossingRate = (int) getGraphPanel_ZCR().getSelectedValue();
					model.addElement(slice);
				}
			}
			@Override
			public void mousePressed(MouseEvent p) {
				isDrag = true;
				sx = p.getX();
				GraphPanel gp = ((GraphPanel)p.getComponent());
				sGraph = gp.getSelectedGraph();
				
				if(sGraph==-1) isDrag = false; //adn grafy
				
			}
			@Override
			public void mouseReleased(MouseEvent p) {
				isDrag = false;
			}
		};
		graphPanel.addMouseListener(ma);
		graphPanel_dev.addMouseListener(ma);
		graphPanel_frequency.addMouseListener(ma);
		graphPanel_ZCR.addMouseListener(ma);
		
		MouseMotionListener mml = new MouseMotionAdapter() {
			@Override
			public void mouseDragged(MouseEvent p) {
				if(!isDrag) return;
				int drag = p.getX()-sx;
				sx = p.getX();
				graphPanel.addDeltaX(sGraph, drag);
				graphPanel_dev.addDeltaX(sGraph, drag);
				graphPanel_frequency.addDeltaX(sGraph, drag);
				graphPanel_ZCR.addDeltaX(sGraph, drag);
			}
		};
		graphPanel.addMouseMotionListener(mml);
		graphPanel_dev.addMouseMotionListener(mml);
		graphPanel_frequency.addMouseMotionListener(mml);
		graphPanel_ZCR.addMouseMotionListener(mml);
		
		// co se stane kdy je nahrn zvuk
				sc.setOnRecordingCompleted(new Runnable() {
					
					@Override
					public void run() {
						OnWaveRecorded();
					}
				});
				
				//co se stane kdy se my pohybuj nad grafem
				GraphPanel.Runnable<Integer, Integer> r= new GraphPanel.Runnable<Integer, Integer>() {
					
					@Override
					public void run(Integer param, Integer p2) {
						// zobraz informace v bod na vech grafech
						getGraphPanel().setShowPoint(param, p2);
						getGraphPanel_ZCR().setShowPoint(param, p2);
						getGraphPanel_frequency().setShowPoint(param, p2);
						getGraphPanel_dev().setShowPoint(param, p2);
					}
				};
				getGraphPanel().setShowPointChanged(r);
				getGraphPanel_ZCR().setShowPointChanged(r);
				getGraphPanel_frequency().setShowPointChanged(r);
				getGraphPanel_dev().setShowPointChanged(r);
				
	}
	
	
	public GraphPanel getGraphPanel() {
		return graphPanel;
	}
	public GraphPanel getGraphPanel_dev() {
		return graphPanel_dev;
	}
	public GraphPanel getGraphPanel_ZCR() {
		return graphPanel_ZCR;
	}
	public GraphPanel getGraphPanel_frequency() {
		return graphPanel_frequency;
	}
	public JList<RezOtiskuZvuku> getList() {
		return list;
	}
	
	
	
	
	private static void addPopup(Component component, final JPopupMenu popup) {
		component.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				if (e.isPopupTrigger()) {
					showMenu(e);
				}
			}
			public void mouseReleased(MouseEvent e) {
				if (e.isPopupTrigger()) {
					showMenu(e);
				}
			}
			private void showMenu(MouseEvent e) {
				popup.show(e.getComponent(), e.getX(), e.getY());
			}
		});
	}
	private class SwingAction extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		
		public SwingAction() {
			putValue(NAME, "Smazano");
			putValue(SHORT_DESCRIPTION, "Smazan Zvuk");
		}
		public void actionPerformed(ActionEvent e) {
			for(RezOtiskuZvuku i: getList().getSelectedValuesList())
				model.removeElement(i);
		}
	}
	protected JTextField getTxtSamplestxt() {
		return txtVzorkytxt;
	}
	/**
	 * Vytvoen ramu/framu
	 */
	//-------------------------------Konec GUI-------------------------//
	PrehravacZvuku playback = new PrehravacZvuku();
	public UiAnalyzator() {
		
		Initialize();
		
		playback.setOnShutdown(new Runnable() {
			
			@Override
			public void run() {
				getBtnPlay().setText("Pehraj");
			}
		});
		
		playback.setPlaybackTimer(new Runnable() {
			
			@Override
			public void run() {
				getGraphPanel().setShowPoint(getGraphPanel().getNumGraphs()-1, playback.progress);
				
			}
		});
	}
	
	
	ZznamZvuku sc = new ZznamZvuku(true);	//pro zznam zvuku
	private JButton btnPlay;
	
	
	private void StartRecording(){
		sc.start();
	}
	private void StopRecording(){
		sc.stop();
		
		
	}
	private void startPlayback(){
		try {
			playback.start( sc.getAudioStream());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
		
	private void stopPlayback(){
			playback.stop();
	}
	// co se stane kdy je zvuk nahrn
	void OnWaveRecorded(){
		ActionZvukovyOtisk fp;				
			
		try {
			//extraktovn zvuku pi vchozm nastaven low-pass, high-pass a robustness
			fp = DetektorVlastnosti.extractFingerprint(new Wave(sc.getRecordedStream()), 10000, 100, 6);
			
			/*co se dje na nsledujcch dcch?
			 * 
			 * Vechny parametry jsou konvertovany do pole double hodnot a jsou k dispouici GrafPanelu
			 * pro renderovani
			 */
			
			int i;
			double []data;
			data = new double[fp.slices.size()];
			i=0;
			for(RezOtiskuZvuku s:fp.slices){
				data[i++]=s.intenzita;
			}
				
			getGraphPanel().addGraph(data); //pidat graf
			
			
			//tento postup se zopakuje u vech dalch graf
			data = new double[fp.slices.size()];
			i=0;
			for(RezOtiskuZvuku s:fp.slices){
				data[i++]=s.smerOdchylka;
			}
				
			this.getGraphPanel_dev().addGraph(data);
			
			data = new double[fp.slices.size()];
			i=0;
			for(RezOtiskuZvuku s:fp.slices){
				data[i++]=s.ZeroCrossingRate;
			}
				
			this.getGraphPanel_ZCR().addGraph(data);
			
			
			data = new double[fp.slices.size()];
			i=0;
			for(RezOtiskuZvuku s:fp.slices){
				data[i++]=s.frekvence;
			}
				
			this.getGraphPanel_frequency().addGraph(data);
			
			//-------------------------------------------------------------//
			
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	//export parametr do souboru
	void exportSamples(){
		FileWriter fw;
		try {
			fw = new FileWriter(getTxtSamplestxt().getText());	//prava jmna textovho souboru podle chlveku
			//export parametr do souboru
			for(int i=0;i<model.getSize();i++){
				RezOtiskuZvuku slice = model.get(i);
				fw.write(slice.getString());
				
			}
			fw.close();
		} catch (IOException e) {
			
			JOptionPane.showMessageDialog(null, e.toString());//zobraz chybu v ppad selhn programu
			e.printStackTrace();
		}
		
		
	}
	
	
	protected JButton getBtnPlay() {
		return btnPlay;
	}
}

