package com.Felipe;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;

import com.Felipe.Actions.TleskaniAction;
import com.Felipe.Actions.KlepaniAction;
import com.Felipe.Actions.PiskaniAction;
import com.Felipe.Drawing.WaveMatchViewer;
import com.Felipe.Wave.ActionZvukovyOtisk;
import com.Felipe.Wave.ActionVlastnostiZvukovehoOtisku;
import com.Felipe.Wave.DetektorVlastnosti;
import com.Felipe.Wave.DetektorAnylyzaZvuku;
import com.Felipe.Wave.DetektorAnylyzaZvuku.FingerprintMatches;
import com.musicg.wave.Wave;

public class UiForm extends JFrame implements Runnable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private JPanel contentPane;

	//-------------GUI-------------------------------------
	private JLabel lblResultsHere;
	private final Action action = new SwingAction();
	
	/**
	 * Vytvo okno.
	 */
	private void InitializeComponents() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 406);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnAction = new JMenu("Nstroje");
		menuBar.add(mnAction);
		
		JMenuItem mntmAnalyze = new JMenuItem("Analza");
		mntmAnalyze.setAction(action);
		
		mnAction.add(mntmAnalyze);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
		
		JPanel panel_2 = new JPanel();
		contentPane.add(panel_2);
		panel_2.setLayout(new BoxLayout(panel_2, BoxLayout.Y_AXIS));
		
		scrollPane_1 = new JScrollPane();
		panel_2.add(scrollPane_1);
		
		panel_mv = new JPanel();
		scrollPane_1.setViewportView(panel_mv);
		panel_mv.setLayout(new BoxLayout(panel_mv, BoxLayout.Y_AXIS));
		
		slider = new JSlider();
		panel_2.add(slider);
		
		JPanel panel = new JPanel();
		panel.setBorder(new EmptyBorder(0, 3, 0, 3));
		contentPane.add(panel);
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		final JButton btnRecord = new JButton("Nahraj");
		btnRecord.setAlignmentX(Component.CENTER_ALIGNMENT);
		panel.add(btnRecord);
		btnRecord.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if(btnRecord.getText().equals("Nahraj")){
					btnRecord.setText("Stop");
					StartRecording();
				}
				else{
					btnRecord.setText("Nahraj");
					StopRecording();
				}
			}
		});
		btnRecord.setHorizontalAlignment(SwingConstants.LEFT);
		
		btnPlay = new JButton("Pehraj");
		btnPlay.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnPlay.getText().equals("Pehraj"))
				{
					btnPlay.setText("Stop");
					startPlayback();
					
				}
				else{
					btnPlay.setText("Pehraj");
					stopPlayback();
					
				}
				
			}
		});
		panel.add(btnPlay);
		
		lblResultsHere = new JLabel("Vsledek men zde");
		lblResultsHere.setBorder(new EmptyBorder(0, 5, 0, 0));
		lblResultsHere.setAlignmentX(Component.CENTER_ALIGNMENT);
		panel.add(lblResultsHere);
		lblResultsHere.setHorizontalAlignment(SwingConstants.CENTER);
		
	}
	public JLabel getLblResultsHere() {
		return lblResultsHere;
	}
	
	
	
	private class SwingAction extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		public SwingAction() {
			putValue(NAME, "Analza");
			putValue(SHORT_DESCRIPTION, "Analyza zvukove vlny pro detekci typu zvuku");
		}
		public void actionPerformed(ActionEvent e) {
			UiAnalyzator frame = new UiAnalyzator();
			frame.setVisible(true);
			
		}
	}

	//------------------------------------------------------------------//
	//Runnable
	@Override
	public void run() {
		CompareWave();
	}

	//----------------------Logika-------------------------------//
	
	
	ZznamZvuku sc = new ZznamZvuku(true);				//pro nhrvn zvuku
	
	DefaultListModel<ActionVlastnostiZvukovehoOtisku> lm;	//seznam otisk
	DetektorAnylyzaZvuku wd = new DetektorAnylyzaZvuku();		//identifikuje zvuky formatu wave
	PrehravacZvuku playback = new PrehravacZvuku();
	private JButton btnPlay;
	private JScrollPane scrollPane_1;
	private JPanel panel_mv;
	private JSlider slider;
	
	public UiForm(){
		super("Klasifikace zvuku");
		
		InitializeComponents();				//init gui
		
		sc.setOnRecordingCompleted(this);	//vykon se kdy je zaznamenn zvuk
		playback.setOnShutdown(new Runnable() {
			
			@Override
			public void run() {
				getBtnPlay().setText("Pehraj");
			}
		});
		
		playback.setPlaybackTimer(new Runnable() {
			
			@Override
			public void run() {
				getSlider().setValue((int)(playback.progress*getSlider().getMaximum()));
				
			}
		});
		
		lm = new DefaultListModel<>();
		
		//--------V ppad rozen programu doplnit ZDE----------//
		wd.addAction(new PiskaniAction());
		wd.addAction(new TleskaniAction());
		wd.addAction(new KlepaniAction());
		
		
		//----Pidat Novou tdu do balku detekovatelnch zvuk (Action)-----------//
		for(ActionVlastnostiZvukovehoOtisku p:wd.getActions()){
			lm.addElement(p);
			getPanel_mv().add(new WaveMatchViewer());
		}
		//int cc = getPanel_mv().getComponentCount();
		//CompareWave();
	}
	
	private void StartRecording(){
		sc.start();
	}
	private void StopRecording(){
		sc.stop();
		
		
	}
	
	//porovnn vlny s ped definovanmi zvuky
	private void CompareWave(){
		Wave wave;
		try {
			
			wave = new Wave(sc.getRecordedStream());			//zskn vlny z nahranho zvuku
			ActionZvukovyOtisk fp = DetektorVlastnosti.extractFingerprint(wave, 10000, 100, 4);
			DetektorAnylyzaZvuku.FingerprintMatchResult r = wd.exportMatches(fp);
			getLblResultsHere().setText(r.probableAction);
			int i=0;
			for(FingerprintMatches m:r.matches){
				WaveMatchViewer wmv= (WaveMatchViewer) getPanel_mv().getComponent(i++);
				wmv.setTotalFrames(fp.slices.size());
				wmv.setFpm(m);
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//l1.setText("Is whistle probability: "+waveTypeDetector.getWhistleProbability());
		//nepouv se, pvodn Musicg
	}
	
	private void startPlayback(){
		try {
			playback.start( sc.getAudioStream());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
		
	private void stopPlayback(){
			playback.stop();
	}
		
		
	protected JButton getBtnPlay() {
		return btnPlay;
	}
	
	protected JPanel getPanel_mv() {
		return panel_mv;
	}
	public JSlider getSlider() {
		return slider;
	}
}

