package com.Felipe.Wave;

import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

import com.musicg.wave.Wave;

/*
 * pouva se pro detekovn typu vlny
 * Zdroj: hodn se li od 'com.musicg.wave.WaveTypeDetector'
 */

public class DetektorAnylyzaZvuku {

	//seznam vech monch detekovanch akc
	List<ActionVlastnostiZvukovehoOtisku> actions = new LinkedList<ActionVlastnostiZvukovehoOtisku>();

	public List<ActionVlastnostiZvukovehoOtisku> getActions(){
		return actions;
	}
	
	//pouvan v UiForm
	public void addAction(ActionVlastnostiZvukovehoOtisku prop){
		//pidej Akci(Action) do seznamu
		actions.add(prop);
	}

	// Vrac vsledek porovnvn vlny s existujcmi otisky zvuku
	public FingerprintMatchResult exportMatches(ActionZvukovyOtisk fp){

		FingerprintMatchResult r = new FingerprintMatchResult(); //nvrac vsledek
		
		r.maxSimilarity = 0;
		r.probableAction = "Neznm";
		r.matches = new LinkedList<FingerprintMatches>();
		
		for(ActionVlastnostiZvukovehoOtisku prop:actions){
			FingerprintMatches m = new FingerprintMatches();
			m.actionName = prop.jmeno;
			m.similarity = 0;
			m.matches = new LinkedList<RezOtiskuZvuku>();

			for(RezOtiskuZvuku slice:fp.slices){
				if(isInRange(slice.intenzita, prop.minIntenzita, prop.maxIntenzita))
					if(isInRange(slice.smerOdchylka, prop.minSmerOdchylka, prop.maxSmerOdchylka))
						if(isInRange(slice.ZeroCrossingRate, prop.minNumZeroCross, prop.maxNumZeroCross))
							if(isInRange(slice.frekvence, prop.minFrekvence, prop.maxFrekvence)){
								m.similarity++;
								m.matches.add(slice);
							}
								


			}

			//pokud (Similarity<prop.QualifyingPasses) Similarity=0;

			if(m.similarity>r.maxSimilarity){
				r.maxSimilarity = m.similarity;
				r.probableAction = m.actionName;
			}
			r.matches.add(m);
		}
		//nvrat vsledk
		return r;
	}

	//Detekovn typu zvuku(Action) v nahranm zvuku
	public String detectWave(Wave wave, boolean debug) throws IOException{

		//pomoc definovanch low pass, high pass a robustness
		ActionZvukovyOtisk fp = DetektorVlastnosti.extractFingerprint(wave, 10000, 100, 4);
		
		double maxSimilarity = 0;
		
		String Action = "neznamy";
		
		FileWriter fw = null;
		if(debug)
		{
			fw = new FileWriter("debug.txt"); //vytvo doubor
		}
		
		for(ActionVlastnostiZvukovehoOtisku prop:actions){
			double Similarity = 0;

			for(RezOtiskuZvuku slice:fp.slices){
				if(isInRange(slice.intenzita, prop.minIntenzita, prop.maxIntenzita))
					if(isInRange(slice.smerOdchylka, prop.minSmerOdchylka, prop.maxSmerOdchylka))
						if(isInRange(slice.ZeroCrossingRate, prop.minNumZeroCross, prop.maxNumZeroCross))
							if(isInRange(slice.frekvence, prop.minFrekvence, prop.maxFrekvence)){
								Similarity++;
								
							}
								


			}

			//pokud (Similarity<prop.QualifyingPasses) Similarity=0;

			if(Similarity>maxSimilarity){
				maxSimilarity = Similarity;

				Action = prop.toString();
			}
		}
		System.out.println(maxSimilarity+"");
		if(debug) fw.close();
		return Action;
	}

	boolean isInRange(double val, double min, double max){
		return (val >= min && val <= max);
	}
	boolean isInRange(int val, int min, int max){
		return (val >= min && val <= max);
	}
	
	public class FingerprintMatches{
		public String actionName;
		public List<RezOtiskuZvuku> matches;
		public double similarity;
	}
	public class FingerprintMatchResult{
		public List<FingerprintMatches> matches;
		public double maxSimilarity;
		public String probableAction;
	}
}
